//
//  StockAdminController.m
//  IDLExplorer
//
//  Created by Victor on 1/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "StockAdminController.h"
#import "StockWatchController.h"
#import "QuoteItem.h"

@implementation StockAdminController

@synthesize _server;

- initWithController:(StockWatchController*)ctrl
{
    if (self = [super initWithNibName:@"Admin" bundle:[NSBundle bundleForClass:[self class]]]) {
		_controller = ctrl;
		_item = [[QuoteItem alloc]init];
    }
    return self;
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
	[_server release];
	[_item release];
    [super dealloc];
}

- (void) updateQuote
{
	[_item setSymbol:symbolField.text];
	[_item setName:nameField.text];
	[_item setQuote:[valueField.text doubleValue]];
	[_item setMarket:marketField.text];
	[_item setVolume:[volumeField.text doubleValue]];
}

- (void) addSymbol:sender
{
	if(!_server){
		@try{
			self.server = [[_controller server]getStockAdmin];
			[_server setDelegate:self];
		}@catch(NSException *e){
			UIAlertView *alert = [[UIAlertView alloc] initWithTitle:[e name] message:[e reason]
														   delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
			[alert show];	
			[alert release];
		}
	}
	if(_server) @try{
		[self updateQuote];
		[_server addQuote:_item];
	}@catch(NSException *e){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:[e name] message:[e reason]
													   delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
		[alert show];	
		[alert release];
	}
}

- (void) objectDidInvalidate:(NSNotification*)notification
{
	if([notification object] == _server){
		self.server = nil;
	}
}

- (void) done:sender
{
	[self dismissModalViewControllerAnimated:YES];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	[textField resignFirstResponder];
	return YES;
}

@end
