//
//  UStockWatch.h
//  IDLExplorer
//
//  Created by Victor on 1/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <ADORB/ADORB.h>

@class ConnectController;
@class SymbolController;
@class QuoteItem;

@protocol CORBAObject;
@protocol StockAdmin;

@protocol StockWatch<CORBAObject>
- (void) notify:(NSArray*)quotes;
@end

@interface CORBAObject(StockWatch) <StockWatch>

@end

@protocol StockMarket<CORBAObject>
- (id<StockAdmin>) getStockAdmin;
- (double) getQuoteValue:(NSString*)symbol;
- (void) stop:(id<StockWatch>)client;
- (NSString*) _getName;
- (void) unsubscribe:(id<StockWatch>)client symbol:(NSString*)symbol;
- (QuoteItem*) subscribe:(id<StockWatch>)client symbol:(NSString*)symbol;
- (void) start:(id<StockWatch>)client;
@end

@interface CORBAObject(StockMarket) <StockMarket>

@end


@interface StockWatchController : UIViewController <StockWatch>
{
	IBOutlet UIWindow *window;
	IBOutlet UITableView *tableView;
	IBOutlet UINavigationBar *navigationBar;
	IBOutlet UIToolbar *toolbar;
	IBOutlet UIBarButtonItem *watchButton;
	IBOutlet UIBarButtonItem *iorButton;
	IBOutlet UIBarButtonItem *addButton;
	IBOutlet UIBarButtonItem *adminButton;
	id _server;
	id _admin;
    NSMutableArray* quoteArray;
	ConnectController *connectController;
	SymbolController *symbolController;
	BOOL _watching;
}

@property(retain, nonatomic, getter=server, setter=setServer) id _server;
@property(retain, nonatomic, getter=admin, setter=setAdmin) id _admin;
@property(getter=isWatching) BOOL watching;

- (void) connect:sender;
- (void) openStockAdmin:(id)sender;
- (void) addSymbol:sender;
- (void) watch:sender;

- (void) addSymbolWithName:(NSString*)name;
@end
