/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import "OctetArrayFormatter.h"


@implementation OctetArrayFormatter

- (BOOL)isPartialStringValid:(NSString *)partialString 
        newEditingString:(NSString **)newString errorDescription:(NSString **)error
{
    int len = [partialString length];
    BOOL rc = YES;
    if(len <= 2*_count){
        int l;
        for(l = 0;l<len;l++){
			unichar c = [partialString characterAtIndex:l];
            if(!((c >='0' && c <= '9') ||
                    (c >= 'a' && c <= 'f') ||
                    (c >= 'A' && c <= 'F'))){
                if(error)
                    *error = @"Not a HEX digit in octet sequence";
                rc = NO;
                break;
            }
        }
        *newString = partialString;
        return rc;
    }else{
		if(_count > 0)
			*newString = [partialString substringToIndex:2*_count];
		else
			*newString = @"";
        if(error)
            *error = @"length exceeds maximum";
        return NO;
    }
}

- (BOOL)getObjectValue:(id *)data forString:(NSString *)string errorDescription:(NSString **)error
{
    if([string length] == 2*_count)
        return [super getObjectValue:data forString:string errorDescription:error];
    else
        return NO;
        
}

@end
